//------------------------------------------------------------------------
// QGpsSatMap a GUI widget for satellites
//
//	- programmed by Boyoon Jung
//------------------------------------------------------------------------
#ifndef __QGPSSATMAP_H
#define __QGPSSATMAP_H

// header files for GPS device
#include <gps.h>

// header files for Qt library
#include <qframe.h>
#include <qpixmap.h>
#include <qpainter.h>


// class definition
class QGpsSatMap : public QFrame
{
    private:
	QPixmap _pixmap;	// for double buffering
	QPainter _painter;	// for drawing

	int cx, cy;		// center of a drawing area
	int radius;		// radius of the biggest inscribed circle

	int nsat;		// number of satellites
	satinfo_t sat[12];	// satellite info
	bool active[12];	// active or not

    protected:
	// re-implemented functions
	void resizeEvent (QResizeEvent *);	// when the size of window changes
	void drawContents(QPainter *);		// draw contents
	void drawContentsMask(QPainter *p) { drawContents(p); }

    public:
	// constructor
	QGpsSatMap(QWidget*parent=0, const char *name=0, WFlags f=0);

	// destructor
	~QGpsSatMap();

	// update info
	void updateSatellites(int nsat, satinfo_t sat[], int active[]);
};

#endif // __QGPSSATMAP_H
